
#import <appkit/appkit.h>

#define GK_HS_NO_SLOT -1	// wantSlot when no name to enter
#define GK_HS_DEFAULT_SLOTS 10	// you must use matrices with this many
	// cells in them in your .nibs or funny things might happen.  This
	// needs to be done more cleanly in the future.  (awake method to check
	// size of matrices?)  All matrices should have the same number of
	// cells in them, too.  I don't check this, so you'd better!

@interface GKHighScorePanel:Panel
{
    id	elapsedTimeMatrix;	// all matrices display various slot stuff
    id	endLevelMatrix;		// names correspond to slot instance variables
    id	endTimeMatrix;
    id	finalScoreMatrix;
    id	machineNameMatrix;
    id	playerNameMatrix;
    id	startLevelMatrix;
    id	startTimeMatrix;
    id	userNameMatrix;
	
	id	numberMatrix;		// (which slot # it is) -- needed for growing
			// for a fixed size table, leave this unconnected; if this is
			// connected then the panel will resize the matrices as needed
	
    id	selectPopUp;		// for displaying other tables; queries delegate
	int numSlots;			// how many slots we can display
	int tableNum;			// which table is being displayed?
	int wantSlot, wantTable;	// slot# & table# for name we're waiting
								//to have entered in
}

- initContent:(const NXRect *)contentRect style:(int)aStyle
		backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag;
- setTable:(int)num;		// like below, but can select by number
- changeTable:sender;		// sent when the pop up list selects a new table
- nameEntered:sender;		// sent when when player enters name, fwd. to del.
- ok:sender;				// for the "ok" button on the panel
- resizeMatrixTo:(int)num;	// used to increase table size dynamically
- refresh;					// grabs high score data from delegate, refills
							// all matrices and then updates the screen
- getPlayerName:(int)index table:(int)table; // sent by controller to let
							// the player enter their name in

@end
